//  support function for MOS
//      1 Apr 2016,  no it is not April Fool
//      all MOS support here is deleted
//			13 Apr 2016  Happy Songkran
//      add semaphore		15 Apr 2016

#include "s30.h"

#define  PRIVATE   static

/*   data in S2 space

global variables

nump
currentp

process queue  size 16 words

process control block
struct { PC, SP, ... }   size 16 words

stack of each process size 64 words

memory map

0...900    code
1000       int vec
1500       global var
2000       process queue
2100       process control block
2300       stack

nump      1500     number of process in Q
currentp  1501     pointer to current process
Q		  2000     allocate process queue
qindex    1511     index to Q (current)
qend	  1510     ptr to end of Q
semptr    3000     allocate semaphore

*/

extern int M[];

// interface with mos2.txt
#define nump   		M[1500]
#define currentp  	M[1501]
#define Q			2000
#define qindex  	M[1511]
#define qend		M[1510]

int semptr = 3000;

int newsem(void){
	int a;
	a = semptr;
	M[a] = 1;			// init value to 1
	M[a+1] = 0;			// clear Q
	semptr += 16;
	return a;
}

PRIVATE void blockp(int p){		// terminate p
	M[Q+qindex] = 1;
	nump--;
//	printf("block %d\n",p);
//	interrupt();
}

PRIVATE void wakeup(int p){		// enqueue process queue
	M[qend] = p;
	M[qend+1] = 0;
	qend++;
	nump++;
}

void wait(int sem){
	int v, end;
	M[sem]--;				// value--
	v = M[sem];
	if( v < 0 ){
		end = -v;			// enqueue currentp
		M[sem+end] = currentp;
		M[sem+end+1] = 0;
		blockp(currentp);
	}
}

// dequeue semaphore queue
PRIVATE int desemq(int sem){
	int a, i;
	a = M[sem+1];			// get the first in queue
	i = sem+2;
	while(M[i] != 0){
		M[i-1] = M[i];		// move element left
		i++;
	}
	M[i-1] = 0;
	return a;
}

void signal(int sem){
	int p;
	if( M[sem] < 1 ) M[sem]++;
	if( M[sem] <= 0 ){
		p = desemq(sem);
		wakeup(p);
//		printf("wakeup %d\n",p);
	}
}

/*
//  prototype of nextp()
//  return 0 if no process in the queue
int nextp(void){
	int i;
	if(nump == 0) return 0;
	if(M[Q+qindex] == 1){				// move left
		for(i = Q+qindex; i < qend; i++)
			M[i] = M[i+1];
		qend--;
	}else{
		qindex++;
	}
	if( M[Q+qindex] == 0 )
		qindex = 0;
	return M[Q+qindex];
}
*/
void dumpQ(void){
	int i;
	printf("nump %d; Q idx %d: ",nump,qindex);
	for(i = Q; i<=qend; i++)
		printf("%d ",M[i]);
	printf("\n");
}

/* -------------- for debugging ----------

// compact process Q when length > 5
void compactQ(void){
	int k, m, i, j;
	k = qend - Q;
	if( nump == k ) return;
	if( k > 5 ){
		m = 0;
		for(i = 0; i < qindex; i++)		// count 1 in Q
			if(M[Q+i] == 1) m++;
		j = 0;
		for(i = 0; i < k; i++){			// move left
			if(M[Q+i] != 1){
				M[Q+j] = M[Q+i];
				j++;
			}
		}
		M[Q+j] = 0;		// end Q
		qend = Q + j;
		qindex -= m;
	}
}

void enqueueQ(int p){
	M[qend] = p;
	M[qend+1] = 0;
	qend++;
	nump++;
}

void dumpsem(int sem){
	int i;
	printf("sem %d: ",sem);
	for(i = 0; i<16; i++)
		printf("%d ",M[sem+i]);
	printf("\n");
}

void testQ(void){
	nump = 0;
	qend = Q;
	qindex = 0;			// init Q
	currentp = 111;
	enqueueQ(currentp);
	enqueueQ(222);
	dumpQ();
}

void testsem(void){
	int sem1, p;
	testQ();
	sem1 = newsem();
	wait(sem1);
//	wait(sem1);
//	currentp = 222;
	wait(sem1);
//	wait(sem1);
	signal(sem1);
//	signal(sem1);
//	signal(sem1);
//	signal(sem1);
	dumpsem(sem1);
	dumpQ();
}

// --------------------------
*/
//  queue, Stack are in C space
//int Q[16];
//int qindex = 0;				// index into Q
//int pcbptr = 2100; 			// for pcb alloc
//int stackptr = 2300;		// for stack alloc

/*
int newp(void){
	int a;
	a = pcbptr;
	pcbptr += 16;
	return a;
}

int newStack(void){
	int a;
	a = stackptr;
	stackptr += 64;
	return a;
}

//  Q is an array of PCB pointer
//    nump  keeps the number of process
//    Q[.] = 0    the end of queue
//    Q[.] = 1    terminated state of process
//    Q[qindex]   pointer to current process

void enqueue(int p){
	int i;
	i = 0;
	while(Q[i] != 0) 	// find end of Q
		i++;
	Q[i] = p;
	Q[i+1] = 0;
	nump++;
}

void terminate(void){
	Q[qindex] = 1;
	nump--;
}

//  return 0 if no process in the queue
int nextp(void){
	if(nump == 0) return 0;
	qindex++;
	while( Q[qindex] == 1 || Q[qindex] == 0 ){
		if(Q[qindex] == 0) qindex = 0;
		if(Q[qindex] == 1) qindex++;
	}
	return Q[qindex];
}
*/
